DECLARE FUNCTION KillBlanks$ (X!)
'
' Fonts.Bas - - to be compiled under MicroSoft QuickBasic 4.0
'
' A font downloader for the Hewlett-Packard LaserJet+, 500+, and Series II
' Printers.  Written October 20, 1987 by Jeffrey R. Drumm.
'
' Version Number 1.0
'
' Rev. November 11, 1987 to clean up comments.
'
ON ERROR GOTO ErrorHandler
'
' Read command line, pass to a variable
'
LET FontFileName$ = COMMAND$
'
' If command line is blank, assign default file name for font list.
'
IF FontFileName$ = " " THEN
	FontFileName$ = "FONT.LST"
END IF
'
' Show off my name
'
CLS
COLOR 15, 4
PRINT "FONTS: The Font Loader, for Hewlett-Packard LaserJet+ Soft Fonts. "
PRINT "                                                                  "
PRINT "     by Jeffrey R. Drumm                                          "
PRINT "        ValCom Computer Center                                    "
PRINT "        470 Forest Ave.                                           "
PRINT "        Portland, Maine  04101                                    "
PRINT "        207-775-5055                                              "
COLOR 7, 0
'
' Initialize Printer
'
OPEN "PRN" FOR OUTPUT AS #1
PRINT #1, CHR$(27); "E";
'
' Open Font selection file and get first Font name
'
OPEN FontFileName$ FOR INPUT AS 2
'
' Get starting Font ID Number
'
INPUT #2, FontId$
'
' Set up Loop for Font Selection and ID assignment
'
WHILE NOT EOF(2)
	 '
	 ' Get Font Name from disk file
	 '
	 INPUT #2, FontName$
	 IF FontName$ <> "" THEN
		  '
		  ' Assign Font ID number
		  '
		  PRINT #1, CHR$(27); "*c"; FontId$; "D";
		  '
		  ' Build command line for Shell statement
		  '
		  CommandLine$ = "Copy /B " + FontName$ + " PRN: > NUL:"
		  '
		  ' Display font name and ID number on screen
		  '
		  LOCATE 9, 1
		  COLOR 7, 1
		  PRINT "Downloading ";
		  COLOR 15, 1
		  PRINT FontName$;
		  COLOR 7, 1
		  PRINT " as font number ";
		  COLOR 15, 1
		  PRINT FontId$;
		  '
		  ' Copy font to printer port
		  '
		  SHELL CommandLine$
		  '
		  ' Set font to Permanent
		  '
		  PRINT #1, CHR$(27); "*c"; FontId$; "d5F";
		  '
		  ' Reset Printer
		  '
		  PRINT #1, CHR$(27); "E";
	END IF
	FontId$ = KillBlanks$(VAL(FontId$) + 1)
WEND
CLOSE #2
CLOSE #1
COLOR 15, 4
CLS
'
LOCATE 12, 35
PRINT "All Done!"
'
' Provide user with audible signal that copying process is done.
' In this case, Beethoven's Fifth does the job.
'
PLAY "T180 O2 P2 P8 l8 GGG"
' End of Program.
'
SYSTEM
'
ErrorHandler:
CLS
PRINT "Your Font Name file does not exist, or is not in the named"
PRINT "directory.  The default filename is FONT.LST, in the current"
PRINT "directory.  If your Font Name file is named or located differently,"
PRINT "use the command:"
PRINT " "
PRINT "FONTS pathname\fontname.lst"
PRINT " "
PRINT "Where pathname is the drive and directory of the Font Name file, "
PRINT "and fontname.lst is the name of your font name file."
SYSTEM

FUNCTION KillBlanks$ (X) STATIC
X$ = STR$(X)
KillBlanks$ = LTRIM$(RTRIM$(X$))
END FUNCTION

